// if the base class of an object implements an interface, all sub-classes do, too
public class ImplementationAEx extends ImplementationA {
	public static void main(String[] args) {
		InterfaceA myInterface = new ImplementationA();
		// this is possible because ImplementationA implements InterfaceA
		
		//InterfaceA someObject = new Object();
		// doesn't work: Type mismatch: cannot convert from Object to InterfaceA
		
		// but this works, too:
		InterfaceA anotherInterfaceObject = new ImplementationAEx();
		// because we extend ImplementationA which implements InterfaceA
		
		if( anotherInterfaceObject instanceof InterfaceA ) {
			System.out.println( "anotherInterfaceObject is an instance of InterfaceA, too, consequently" );
		}
	}

}
